/*	=============================================================================
*
*	Hide and Seek for Day of Defeat: Source
*
*	=============================================================================
*
*	This program is free software; you can redistribute it and/or modify it under
*	the terms of the GNU General Public License, version 3.0, as published by the
*	Free Software Foundation.
*
*	This program is distributed in the hope that it will be useful, but WITHOUT
*	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
*	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
*	details.
*
*	You should have received a copy of the GNU General Public License along with
*	this program. If not, see <http://www.gnu.org/licenses/>
*
* =============================================================================
*/

enum ConVars
{
	Handle:Enabled,
	Handle:WinLimit,
	Handle:HideTime,
	Handle:InfoPanel,
	Handle:MenuSelection,
	Handle:RoundTime,
	Handle:MinPlayers,
	Handle:BeaconLastMan,
	Handle:RoundTimerBeacon,
	Handle:BeaconOneMinLeft,
	Handle:BeaconTwoMinLeft,
	Handle:BeaconLastManInterval
}

new g_ConVar[ConVars];

LoadConVars()
{
	CreateConVar("sm_hidenseek_version", PL_VERSION, "Hide & Seek Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED);

	g_ConVar[Enabled] 	            = CreateConVar("sm_hidenseek_enabled",                 "1",   "Active/désactive Hide & Seek.", FCVAR_PLUGIN|FCVAR_NOTIFY);
	g_ConVar[WinLimit]	            = CreateConVar("sm_hidenseek_winlimit",                "4",   "Nombre de rounds avant un changement de Map.", FCVAR_PLUGIN|FCVAR_NOTIFY);
	g_ConVar[HideTime]	            = CreateConVar("sm_hidenseek_hidetime",                "90",  "Combien de temps pour se cacher en début de round. (en secondes)", FCVAR_PLUGIN|FCVAR_NOTIFY);
	g_ConVar[InfoPanel]             = CreateConVar("sm_hidenseek_infopanel",               "1",   "Montrer les infos au joueurs lorsqu'ils se connectent.", FCVAR_PLUGIN|FCVAR_NOTIFY);
	g_ConVar[MenuSelection]         = CreateConVar("sm_hidenseek_menuselection",           "1",   "autorise ou pas les joueurs à ne changer qu'une seule fois de déguisement.", FCVAR_PLUGIN|FCVAR_NOTIFY);
	g_ConVar[RoundTime]             = CreateConVar("sm_hidenseek_roundtime",               "360", "Temps (en secondes) de chaque round.", FCVAR_PLUGIN|FCVAR_NOTIFY, true, 120.0);
	g_ConVar[MinPlayers]            = CreateConVar("sm_hidenseek_minplayers",              "3",   "Nombre minimum de joueur pour commencer la partie.", FCVAR_PLUGIN|FCVAR_NOTIFY, true, 3.0);
	g_ConVar[BeaconLastMan]         = CreateConVar("sm_hidenseek_beacon_lastman",          "1",   "Active/désactive beacon sur le dernier survivant.", FCVAR_PLUGIN|FCVAR_NOTIFY);
	g_ConVar[RoundTimerBeacon]      = CreateConVar("sm_hidenseek_beacon_roundtimer",       "1",   "Active/désactive beacon fin de partie.", FCVAR_PLUGIN|FCVAR_NOTIFY);
	g_ConVar[BeaconOneMinLeft]      = CreateConVar("sm_hidenseek_beacon_oneminleft",       "1",   "Nombre de beacons lorsqu'il reste 1 minute.", FCVAR_PLUGIN|FCVAR_NOTIFY);
	g_ConVar[BeaconTwoMinLeft]      = CreateConVar("sm_hidenseek_beacon_twominleft",       "2",   "Nombre de beacons lorsqu'il reste 2 minutes.", FCVAR_PLUGIN|FCVAR_NOTIFY);
	g_ConVar[BeaconLastManInterval] = CreateConVar("sm_hidenseek_beacon_lastman_interval", "30",  "Délai entre les beacons pour le dernier survivant.", FCVAR_PLUGIN|FCVAR_NOTIFY);

	HookConVarChange(g_ConVar[Enabled], ConVarChange_Enabled);
}

public ConVarChange_Enabled(Handle:hConVar, const String:szOldValue[], const String:szNewValue[])
{
	if (StrEqual(szNewValue, "0"))
	{
		g_bModRunning = false;

		SetRoundState(DoDRoundState_Restart);
	}
}